using System;
using System.Collections.Generic;
using System.Text;

namespace hiperbula
{
    class Parabula
    {
        //     
        private double[] data;
        
        public Parabula(double a,double b,double c)
            // 
            //: a!=0
            {
                this.data = new double[3];
                this.data[2] = a;
                this.data[1] = b;
                this.data[0] = c;
            }

        public double calculateY(double x)
        {
            //    
            double y=0;
            for (int i = 0; i < 3; i++)
                y = y + this.data[i] * Math.Pow(x, i);
            return y;
        }

        public double[] getRoots()
        {
            double delta = Math.Pow(this.data[1], 2) - 4 * this.data[2] * this.data[0];
            if (delta < 0)
               {
                double[] roots = new double[0];
                return roots;
               }
            if (delta == 0)
               {
                    double[] roots = new double[1];
                    roots[0] = -this.data[1] / (2*this.data[2]);
                    return roots;
               }
               if (delta > 0)
               {
                   double[] roots = new double[2];
                   roots[0] = (-this.data[1] + Math.Sqrt(delta)) / (2 * this.data[2]);
                   roots[1] = (-this.data[1] - Math.Sqrt(delta)) / (2 * this.data[2]);
                   return roots;
               }
               return null;
        }

        public bool isOnTheGraph(Point p)
        {
            double y = calculateY(p.getX());
            return (y == p.getY());
        }

        public Point getMinMax()
        {
            //            
            double x=-this.data[1]/(2*this.data[2]);
            double y = (4 * this.data[2] * this.data[0] - Math.Pow(this.data[1], 2)) / (4 * this.data[2]);
            Point m=new Point(x,y);
            return m;
        }
        public string toString()
        {
            String str = "";
            str = str +"<"+ this.data[2] + ">x^2" ;
            str = str + "+<" + this.data[1] + ">x";
            str = str + "+<"+this.data[0]+">";
            return str;
        }
    }
}
